=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2008-04-17 01:00:34 +0000
+++ loggerhead/controllers/revision_ui.py	2008-04-18 00:00:58 +0000
@@ -96,6 +96,8 @@
                 'compare_revid': compare_revid,
                 'side_by_side': side_by_side,
                 'line_count': line_count,
+                'line_count_limit': 3000,
+                'show_plain_diffs': line_count > 3000,
             }
             h.flush_cache()
             self.log.info('/revision: %r seconds' % (time.time() - z,))

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-04-14 22:40:03 +0000
+++ loggerhead/history.py	2008-04-18 00:00:58 +0000
@@ -816,7 +816,7 @@
                     diff = buffer.getvalue()
             else:
                 diff = ''
-            out.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=self._process_diff(diff)))
+            out.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=self._process_diff(diff), raw_diff=diff))
 
         return out
 

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2007-09-04 01:47:51 +0000
+++ loggerhead/static/css/style.css	2008-04-18 00:00:58 +0000
@@ -450,6 +450,12 @@
     background-color: #dee7ec;
 }*/
 
+pre.diff-plain {
+    border: 1px solid #8cacbb;
+    background-color: #f4f5f8;
+    padding: 1em;
+    font-size: smaller;
+}
 
 /* ----- file inventory ----- */
 

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2008-04-17 01:00:34 +0000
+++ loggerhead/templates/revision.kid	2008-04-18 00:00:58 +0000
@@ -130,22 +130,35 @@
         <tr py:if="change.changes.modified">
             <th class="files"> files modified: </th>
             <td class="files">
+              <span py:if="not show_plain_diffs" py:strip="True">
                 <span py:for="item in change.changes.modified" class="collapse-style-sbs-content">
                     <a href="#${item.filename}-s" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
                 </span>
                 <span py:for="item in change.changes.modified" class="collapse-style-unified-content">
                     <a href="#${item.filename}-u" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
                 </span>
+              </span>
+              <span py:if="show_plain_diffs" py:strip="True">
+                <span py:for="item in change.changes.modified" py:strip="True">
+                    <a href="#${item.filename}" class="filename" title="Jump to ${item.filename} below">${item.filename}</a><br />
+                </span>
+              </span>
             </td>
         </tr>
     </table>
 </div>
 
-<div py:if="change.changes.modified and line_count &gt;= 3000" py:strip="True">
-  Diff of ${line_count} lines is too long to display -- limit is 3000 lines.
+<div py:if="show_plain_diffs" py:strip="True">
+  Diff of ${line_count} lines is too long to display richly -- limit is ${line_count_limit} lines.
+
+  <pre class="diff-plain">
+    <span py:strip="True" py:for="item in change.changes.modified">
+      <a name="${item.filename}" />${item.raw_diff}
+    </span>
+  </pre>
 </div>
 
-<div py:if="change.changes.modified and line_count &lt;= 3000" py:strip="True">
+<div py:if="change.changes.modified and not show_plain_diffs" py:strip="True">
 
 <table class="diff-option-buttons">
 <tr>
@@ -168,7 +181,7 @@
 <!-- ! i'm not a big fan of embedding python code here, but the alternatives all seem to be worse -->
 <?python uniqs={}; ?>
 
-<div class="diff" py:if="change.changes.modified and line_count &lt;= 3000">
+<div class="diff">
     <!-- ! side-by-side diff -->
     <table class="diff-block collapse-style-sbs-content">
         <span py:strip="True" py:for="item in change.changes.modified">

